/*
 * Squawk messenger.
 * Copyright (C) 2019 Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SETTINGS_H
#define SETTINGS_H

#include <QWidget>
#include <QListWidgetItem>
#include <QScopedPointer>
#include <QSettings>
#include <QDir>

#include "shared/global.h"
#include "shared/pathcheck.h"

namespace Ui
{
class Settings;
}

/**
 * @todo write docs
 */
class Settings : public QWidget
{
    Q_OBJECT
public:
    Settings(QWidget* parent = nullptr);
    ~Settings();

signals:
    void changeDownloadsPath(const QString& path);

public slots:
    void apply();
    void confirm();

protected slots:
    void onCurrentPageChanged(QListWidgetItem* current);
    void onVariableModified(const QString& key, const QVariant& value);

private:
    QScopedPointer<Ui::Settings> m_ui;
    std::map<QString, QVariant> modifiedSettings;
};

#endif // SETTINGS_H
